/*
 *  Copyright (C) 2002-2006  The DOSBox Team
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/* $Id: messages.cpp,v 1.18 2006/02/09 11:47:57 qbix79 Exp $ */

#include "dosbox.h"
#include "cross.h"
#include "support.h"
#include "setup.h"

#define LINE_IN_MAXLEN 2048

struct MessageBlock {
	const char* name;
	const char* val;
	MessageBlock(const char* _name, const char* _val):
	name(_name),val(_val){}
};

class listt{
public:
	int count;
	void* listep[256];
	listt(){count=0;}
	~listt(){for(int i=0;i<count;i++) free (listep[i]);}
	void push_back(void* ptr){
		listep[count]=ptr;
		count++;
	}
	void** begin(){
		return listep;
	}
	void** end(){
		return (listep+count);
	}
};

static listt *Lang;
typedef MessageBlock** itmb;

void MSG_Add(const char * _name, const char* _val) {
	/* Find the message */
	WinDrawChars("MSG_Add",7,120,30);
	for(itmb tel=(MessageBlock**)Lang->begin();tel!=(MessageBlock**)Lang->end();tel++) {
		if(!strcmp((*tel)->name,_name)) { 
			return;
		}
	}
	/* Even if the message doesn't exist add it */
	MessageBlock *mb=new MessageBlock(_name,_val);
	Lang->push_back((void*)mb);
	char po[50];
	StrIToA(po,Lang->count);StrCat(po,"    ");
	WinDrawChars(po,StrLen(po),120,30);
}

const char * MSG_Get(char const * msg) {
	for(itmb tel=(MessageBlock**)Lang->begin();tel!=(MessageBlock**)Lang->end();tel++){	
		if(!strcmp((*tel)->name,msg))
		{
			return  (*tel)->val;
		}
	}
	return "Message not Found!\n";
}


void MSG_Write(const char * location) {
	FILE* out=fopen(location,"w+t");
	if(out==NULL) return;//maybe an error?
	for(itmb tel=(MessageBlock**)Lang->begin();tel!=(MessageBlock**)Lang->end();tel++){
		fprintf(out,":%s\n%s.\n",(*tel)->name,(*tel)->val);
	}
	fclose(out);
}

void MSG_Init(Section_prop * section) {
//	char* file_name;
//	LoadMessageFile(section->Get_string("language"));
}

void Lang_Init(){
	Lang=new listt;
}

void Lang_Destroy(){
	delete Lang;
}
