#include <PalmOS.h>    // for PRC Tool compatability
#include <VFSMgr.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include "PalmOSfunc.h"

extern Err err;
int currpos=0;
void puts(char* buff);
char warning_buffer[256];
char *strchr (const char *s,int c);
UInt16 volumeRef;

FILE *fopen(const char* path, char* flags)
 {
	FileRef fr;
	UInt16 openMode=0;
	if (!StrCompare(flags,"rb")||!StrCompare(flags,"r")) openMode=vfsModeRead;
	else if (!StrCompare(flags,"r+")||!StrCompare(flags,"r+b")||!StrCompare(flags,"rb+")) openMode=vfsModeReadWrite;
	else if (!StrCompare(flags,"w")||!StrCompare(flags,"wb")) openMode=vfsModeCreate|vfsModeTruncate|vfsModeWrite;
	else if (!StrCompare(flags,"w+")||!StrCompare(flags,"w+b")||!StrCompare(flags,"wb+")) openMode=vfsModeCreate|vfsModeTruncate|vfsModeReadWrite;
	else if (!StrCompare(flags,"a")||!StrCompare(flags,"ab")) openMode=vfsModeWrite|vfsModeCreate;
	else if (!StrCompare(flags,"a+")||!StrCompare(flags,"a+b")) openMode=vfsModeReadWrite|vfsModeCreate;
	else openMode=vfsModeRead;
	err=VFSFileOpen (volumeRef,path,openMode,&fr);
	if (err!=errNone) return NULL;
	return (FILE*)fr;
 }

/*Int32 open(char* path, UInt32 openMode)
 {
	FileRef fr;
	err=VFSFileOpen (volumeRef,path,openMode,&fr);
	if (err!=errNone) return -1;
	return (Int32)fr;
 }*/

int fclose(FILE *fp)
 {
	FileRef fr=(FileRef)fp;
	err=VFSFileClose(fr);
	if(err==errNone) return 0;
	return -1;
 }
/*
int close(Int32 fh)
 {
	FileRef fr=(FileRef)fh;
	err=VFSFileClose(fr);
	if(err==errNone) return 0;
	return -1;
 }

Int32 REad(UInt32 fh, char* buff, UInt32 nbytes )
 {
	FileRef fr;
	UInt32 nread;
	fr=(FileRef)fh;
	err=VFSFileRead(fr,nbytes,buff,&nread);
	if(nread>0) return nread;
	else if (err==vfsErrFileEOF) return 0;
	return -1;
 }
*/
Int32 fseek(FILE *fp,Int32 offset,Int32 orig)
 {
	err=VFSFileSeek((FileRef)fp,orig,offset);
 	if(err==errNone) return 0;
// 	else if(err==vfsErrFileEOF) return 0;
 	return -1;
 }

Int32 ftell(FILE *fp)
 {
	UInt32 fpos;
	err=VFSFileTell((FileRef)fp,&fpos);
 	if(err!=errNone) return -1;
 	return fpos;
 }
/*
Int32 lseek(int fh,Int32 offset,Int32 orig)
 {
 	UInt32 off;
	err=VFSFileSeek((FileRef)fh,orig,offset);
 	if((err!=errNone)&&(err!=vfsErrFileEOF)) return 0;
 	err=VFSFileTell((FileRef)fh,&off);
 	if(err==errNone) return off;
 	else if(err==vfsErrFileEOF) return off;
 	return -1;
 }
*/
char *fgets(char* buff, int nbytes, FILE *fp)
 {
	FileRef fr;
	UInt32 nread,fpos;
	char *chrp;
	fr=(FileRef)fp;
	if(VFSFileTell(fr,&fpos)!=errNone) return NULL;
	err=VFSFileRead(fr,nbytes-1,buff,&nread);
	if(err!=errNone) if (nread==0)return NULL;
	chrp=strchr(buff,'\n');
	if(chrp==NULL)
	{
		*(buff+nread)='\0';
		return buff;
	}
	nread=(UInt32)chrp-(UInt32)buff+1;
	*(chrp+1)='\0';
	err=VFSFileSeek(fr,vfsOriginBeginning,fpos+nread);
	return buff;
 }

Int32 fread(void* buff, UInt32 size, UInt32 nmemb, FILE *fp)
 {
	FileRef fr;
	UInt32 nread;
	fr=(FileRef)fp;
	err=VFSFileRead(fr,size*nmemb,buff,&nread);
	if((err==errNone)||(err==vfsErrFileEOF)) return nread/size;
	return 0;
 }

Int32 fwrite(unsigned char* buff, UInt32 size, UInt32 nmemb, FILE *fp)
 {
	FileRef fr;
	UInt32 nwrote;
	fr=(FileRef)fp;
	err=VFSFileWrite(fr,size*nmemb,buff,&nwrote);
	if((err==errNone)||(err==vfsErrFileEOF)) return nwrote/size;
	return 0;
 }

Int32 WRite(UInt32 fh, UInt32 nbytes, UInt32 nstr, char* buff)
 {
	FileRef fr;
	UInt32 nwrote;
	fr=(FileRef)fh;
	err=VFSFileWrite(fr,nbytes*nstr,buff,&nwrote);
	if(err!=errNone) return -1;
	return nwrote;
 }

void puts(char* buff)
 {
	WinDrawChars(buff,StrLen(buff),0,10*currpos);
	currpos++;
	if(currpos>15) currpos=0;
 }

Int32 fputs(char* buff, FILE *fp)
{
 	FileRef fr;
 	UInt32 res;
 	fr=(FileRef)fp;
	err=VFSFileWrite(fr,StrLen(buff),buff,&res);
	if(res==StrLen(buff)) return 0;
	return EOF;
}
 
Int32 fputc(int ch, FILE *fp)
{
 	FileRef fr;
 	UInt32 res;
	unsigned char ppp;
	ppp=(unsigned char) ch;
 	fr=(FileRef)fp;
	err=VFSFileWrite(fr,1,&ppp,&res);
	if(res==1) return ch;
	return EOF;
}
 
int fprintf(FILE *fp, const char *fmt, ...)
{
	UInt32 a;
	char *p;
	va_list ap;
	va_start (ap, fmt);
	{
		int x1, x2, x3, x4, x5, x6, x7, x8;
		x1 = va_arg (ap, int);
		x2 = va_arg (ap, int);
		x3 = va_arg (ap, int);
		x4 = va_arg (ap, int);
		x5 = va_arg (ap, int);
		x6 = va_arg (ap, int);
		x7 = va_arg (ap, int);
		x8 = va_arg (ap, int);
		StrPrintF (warning_buffer, fmt, x1, x2, x3, x4, x5, x6, x7, x8);
	}
//	puts(cbuffer);
//	fp=(FILE *)*(12+(char*)a);
	fputs (warning_buffer,fp);
	return StrLen(warning_buffer);
}
