 /*
  * UAE - The Un*x Amiga Emulator
  *
  * Various stuff missing in some OSes.
  *
  * Copyright 1997 Bernd Schmidt
  */

//#include "sysconfig.h"
//#include "sysdeps.h"
#include <stdio.h>
#include "PalmOSfunc.h"
#include "loader.h"
extern struct loader *loadf;

char *mallocs[2000];
//typedef long unsigned int size_t;
int allocs=0;
void callm68k(void*,void*);

void cleanup(){
	int i;
	for(i=0;i<allocs;i++) {
		loadf->newptr=mallocs[i];
		callm68k(loadf->freeptr,NULL);
	}
	allocs=0;
}

void *m_alloc (long n)
{
    void *a;
//    a = MemChunkNew (0,n, memNewChunkFlagAllowLarge |memNewChunkFlagNonMovable);
    loadf->newptr=(void*)n;
    callm68k(loadf->allocptr,NULL);
    a=loadf->newptr;
    if(a) mallocs[allocs++]=(char*)a;
    else {WinDrawChars("Out of RAM, MemChunkNew",23,0,0);while(1);}
    MemSet(a,n,0);
    return a;
}

void m_free (MemPtr p)
{
    int i;
    bool found=false;
    if (!p) return;
    for(i=0;i<allocs;i++){
    	if(!found) {
		if (p==mallocs[i]){
			loadf->newptr=p;
			callm68k(loadf->freeptr,NULL);
			mallocs[i]=NULL;
			found=true;
		}
	}
	if(found) mallocs[i]=mallocs[i+1];
    }
    if (found) allocs--;
//	MemChunkFree(p);

}
char *my_strdup (const char *s)
{
    char *x = (char*)m_alloc(StrLen((char *)s) + 1);
    StrCopy(x, (char *)s);
    return x;
}

void *realloc (void *p, long n)
{
/*    UInt32 osize=MemPtrSize(p);
    UInt32 i;
    if(osize>=n) return p;*/
    void *a;
    a = m_alloc (n);
    if (a == NULL) {
	return NULL;
    }
    if(p!=NULL){
	memcpy(a,p,n-1);
	m_free (p);
    }
    return a;
}

SysAppInfoPtr
SysGetAppInfo( SysAppInfoPtr* appInfoP1, SysAppInfoPtr* appInfoP2 );

//)->memOwnerID
/*
void *xcalloc (long n, long size)
{


    void *a = MemPtrNew (n*size);
    if (a == NULL) {
	write_log ("MemPtrNew memory exhausted : ");
	StrIToA(warning_buffer,n);
	write_log (warning_buffer);
	write_log (" \n");
	abort ("miss1");
    }
    MemSet(a,n*size,0);
    return a;
}*/

char *strchr (const char *s,int c)
{
  do {
    if (*s == c)
      {
	return (char*)s;
      }
  } while (*s++);
  return (0);
}

char *strrchr (const char *s,int c)
{
  char *rtnval = 0;

  do {
    if (*s == c)
      rtnval = (char*) s;
  } while (*s++);
  return (rtnval);
}

/*
char *fgets(char *s, int n, FileRef stream){
	int i;
	UInt32 numRead;
	Err err;
	for (i=0;i<n;i++){
		err=VFSFileRead(stream,1,(s+i),&numRead);
		if (((err!=errNone)||(numRead==0))&&(i==0)) return NULL;
		if(*(s+i)=='\n') {*(s+i)='\0';return s;}
	}
	*(s+i)='\0';
	return s;
}

*/

void abort(void) {};
inline void *New(UInt32 size) {
void *tmp;
	UInt32 i;
/*
	char buf[20];
	MemHeapFreeBytes(0,&i,&j);
	StrIToA(buf,i);
	StrCat(buf,"    ");
	WinDrawChars(buf,StrLen(buf),80,0);
	StrIToA(buf,j);
	StrCat(buf,"    ");
	WinDrawChars(buf,StrLen(buf),80,10);
	StrIToA(buf,size);
	StrCat(buf,"    ");
	WinDrawChars(buf,StrLen(buf),80,20);
*/
	tmp=m_alloc(size);
	if(tmp==NULL){
		WinDrawChars("ALERT!!!",8,0,0);
		while(1);
	}
	callm68k(loadf->memfreebytes,NULL);
	i=(UInt32)loadf->newptr;
	StrIToA(buf+3,i);
	StrCat(buf,"    ");
	WinDrawChars(buf,StrLen(buf),80,40);
	StrIToA(buf,allocs);
//	WinDrawChars (buf,strlen(buf),80,50);
	return tmp;
}
inline void Delete(MemPtr ptr)
{
//	MemHandle memH = MemPtrRecoverHandle(ptr);
//	MemPtrUnlock(ptr);
//	MemHandleFree(memH);
	m_free(ptr);
}
void* operator new(size_t size){return New(size);}
void operator delete(void* ptr){Delete(ptr);}
void* operator new[](size_t size){return New(size);}
void operator delete[](void* ptr){Delete(ptr);}
extern "C" void __cxa_pure_virtual(void) { }

char *
my_strtok_r(char *s, const char *delim, char **lasts)
{
	const char *spanp;
	int c, sc;
	char *tok;

	/* s may be NULL */

	if (s == NULL && (s = *lasts) == NULL)
		return (NULL);

	/*
	 * Skip (span) leading delimiters (s += strspn(s, delim), sort of).
	 */
cont:
	c = *s++;
	for (spanp = delim; (sc = *spanp++) != 0;) {
		if (c == sc)
			goto cont;
	}

	if (c == 0) {		/* no non-delimiter characters */
		*lasts = NULL;
		return (NULL);
	}
	tok = s - 1;

	/*
	 * Scan token (scan for delimiters: s += strcspn(s, delim), sort of).
	 * Note that delim must have one NUL; we stop if we see that, too.
	 */
	for (;;) {
		c = *s++;
		spanp = delim;
		do {
			if ((sc = *spanp++) == c) {
				if (c == 0)
					s = NULL;
				else
					s[-1] = 0;
				*lasts = s;
				return (tok);
			}
		} while (sc != 0);
	}
	/* NOTREACHED */
}

char *
my_strtok(char *s, const char *delim)
{
	static char *lasts;

	return my_strtok_r(s, delim, &lasts);
}

int isalpha (int i){
	if((i>='a')&&(i<='z')) return 1;
	if((i>='A')&&(i<='Z')) return 1;
	return 0;
}

int isdigit (int i){
	if((i>='0')&&(i<='9')) return 1;
	return 0;
}
int isspace(int ch){
	if ((ch>=9)&&(ch<=13)) return true;
	if (ch==' ') return true;
	return false;
}
