#include <PalmOS.h>
#include <PalmTypes.h>
#include <VFSMgr.h>
#include <SoundMgr.h>
#include "header.h"
#include "peal.h"
#include "loader.h"

#define PUAE			"PalmDosBox 0.1"
#define MainForm		1000
#define Contact			1200
#define Start			1010
#define CPUType			1002
#define RAMSize			1006
#define RAMSizePopup		1007

//void HwrEnableDataWrites() SYS_TRAP(sysTrapHwrEnableDataWrites);
//void HwrDisableDataWrites() SYS_TRAP(sysTrapHwrDisableDataWrites);
static Boolean doMainMenu (UInt16 command);
static Boolean appHandleEvent (EventPtr pEvent);
static Boolean mainFormEventHandler (EventPtr pEvent);

unsigned char *window;

    PealModule *pm;
struct loader *loadf;

UInt16 swap16(UInt16 v);
UInt32 swap32(UInt32 v);

WinHandle winh;
BitmapType *bmph;
BitmapTypeV3 *bmphv3,*bmplv3;
char *bits,*scrbits;
UInt16 volumeRef;
UInt16 ownerID=0;
UInt32 rowbytes;
typedef enum {toHeap, toStore, toAny} allocstates;
int cont;

UInt32 ByteSwap32(UInt32 l){
	UInt32 res;
	res=((l>>24)&0xFF);
	res |=((l>>8)&0xFF00);
	res |=((l<<8)&0xFF0000);
	res |=((l<<24)&0xFF000000);
	return res;
}

void delay()
{
   EventType e;
        do {
          EvtGetEvent (&e, evtWaitForever);
        } while ((e.eType != penDownEvent)&& (e.eType != appStopEvent));  
}

void eventloop(EventPtr e,Boolean func(EventPtr),Boolean expr)
{
	Err error;
        do {
          EvtGetEvent (e, evtWaitForever);
          if (!SysHandleEvent(e))
            if (!MenuHandleEvent (0, e, &error))
              if (!func (e))
                FrmDispatchEvent (e);
        } while ((e->eType != appStopEvent)&&(!cont));
}

EventType eve;
char pe[20];
UInt32 fr1,mfr1;
void funcptr(){
	EvtGetEvent ( &eve,0 );
        SysHandleEvent(&eve);
//	if(eve.eType==appStopEvent) loadf->exit=1;
}

void allocptr(){
	fr1=swap32((UInt32)loadf->newptr);
	loadf->newptr=(void*)swap32((UInt32)MemChunkNew(0,fr1,0x1000|0x0200|ownerID));
}

void freeptr(){
	MemChunkFree((void*)swap32((UInt32)loadf->newptr));
}

void memfreebytes(){
	MemHeapFreeBytes(0,&fr1,&mfr1);
	StrIToH(pe,fr1);
	StrIToH(pe+10,mfr1);
	WinDrawChars(pe,8,0,150);
	WinDrawChars(pe+10,8,80,150);
//	loadf->newptr=(void*)swap32(fr);
}

char *heapallocs[20]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
char *storallocs[20]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int nstor=0,nheap=0,armLoc;

void freeall(char *keeparm){
	int i,j,k;
	j=nstor;
	k=nheap;
	for(i=0;i<j;i++){
		if(storallocs[i]==keeparm) continue;
		FtrPtrFree(FTRNUM,i);
		storallocs[i]=0;
		nstor--;
	}
	for(i=0;i<k;i++){
		if(heapallocs[i]==keeparm){
			heapallocs[0]=keeparm;
			continue;
		}
		MemPtrFree(heapallocs[i]);
		heapallocs[i]=0;
		nheap--;
	}
}

char *allocate(UInt32 size,Boolean type)
{
	char *ptr;
	Err err;
	if(size==0) return NULL;
	if(type!=toStore){
		ptr=MemChunkNew(0,size,0x1000|0x0200|ownerID);
		if(ptr!=0){
			heapallocs[nheap]=ptr;
			nheap++;
			return ptr;
		}
		else if(type==toHeap) return NULL;
	}
	err=FtrPtrNew(FTRNUM,nstor,size,(void**)&ptr);
	if(err!=errNone) return NULL;
	storallocs[nstor]=ptr;
	nstor++;
	return ptr;
}

unsigned char *scalercache;
unsigned char *mem;
unsigned long memsize=6;
FileRef logfr=0;
void setloadf()
{
    loadf->e=(EventType*)swap32((UInt32)&eve);
    loadf->bits=(char*)swap32((UInt32)bits);
    loadf->scrbits=(char*)swap32((UInt32)scrbits);
    loadf->rowbytes=swap32(rowbytes);
    loadf->funcptr=(void*)swap32((UInt32)funcptr);
    loadf->allocptr=(void*)swap32((UInt32)allocptr);
    loadf->memfreebytes=(void*)swap32((UInt32)memfreebytes);
    loadf->freeptr=(void*)swap32((UInt32)freeptr);
    loadf->bmph=(BitmapTypeV3*)swap32((UInt32)bmphv3);
    loadf->bmpl=(BitmapTypeV3*)swap32((UInt32)bmplv3);
    loadf->mem=(unsigned char*)swap32((UInt32)mem);
    loadf->scalercache=(unsigned char*)swap32((UInt32)scalercache);
    loadf->memsize=swap32(memsize);
    loadf->logfr=swap32(logfr);
    loadf->volume=swap16((UInt16)volumeRef);
    loadf->exit=0;
}

void *getObjectPtr(FormPtr pForm, Int16 resourceNo)
{
	UInt16 objIndex=FrmGetObjectIndex(pForm,resourceNo);
	return FrmGetObjectPtr(pForm,objIndex);
}

struct inp{
	Int32 bytes_out;
	UInt32 outcnt;
	UInt32 inptr;
	UInt32 *inbuf;
	UInt32 *window;
};

#define armsize 0x120000
Int32 unzip(){
    unsigned char *gbuf;
    unsigned char *addr,*inbuf;
    struct inp inps;
    unsigned char p[4];
    MemHandle mh;
    Int32 *orl;
    Int32 len,res,olen=0;
    FileRef ifr,ofr;
    char code[5]="gunz";
    DmResID resID=1;
    UInt32 *typ;
    char *data;
    inbuf=allocate(0xA0000,toHeap);
    if(inbuf==NULL) return 0;
    window=allocate(armsize,toStore);
    if(window==NULL) {
        freeall(NULL);
        return 0;
    }
    typ=(UInt32*)&code;
    mh=DmGetResource(*typ,resID);
    if(mh==NULL) {
        WinDrawChars("Database not found!",19,50,50);
        freeall(NULL);
        return 0;
    }
    gbuf=MemHandleLock(mh);
    WinDrawChars("Loading Binary ...",18,0,46);
    {
       DmResID resID=1;
       char code[5]="PUae";
       UInt32 ressize;
       MemHandle bmh;
       char *resP;
       typ=(UInt32*)&code;
       bmh=DmGetResource(*typ,resID);
       while(bmh!=NULL)
       {
           resP=MemHandleLock(bmh);
           ressize=MemPtrSize(resP);
           MemMove(inbuf+olen,resP,ressize);
           olen+=ressize;
           resID++;
           MemHandleUnlock(bmh);
           DmReleaseResource(bmh);
           bmh=DmGetResource(*typ,resID);
       }
    }
    WinDrawChars("Done.",5,72,46);
    inps.inbuf=(UInt32 *)inbuf;
    inps.window=(UInt32 *)window;
    inps.outcnt=0;
    inps.inptr=0;
    inps.bytes_out=0;
    pm=PealLoad(gbuf);
    if(pm==NULL){
	MemHandleUnlock(mh);
	DmReleaseResource(mh);
	freeall(NULL);
	return 0;
    }
    addr=PealLookupSymbol(pm,"startup");
    if (addr==NULL){
	WinDrawChars("Can't find symbol, exiting.",27,0,0);
	PealUnload (pm);
	MemHandleUnlock(mh);
	DmReleaseResource(mh);
	freeall(NULL);
	return 0;
    }
    WinDrawChars("Unpacking ...",13,0,58);
    MemSemaphoreReserve(true);
    res=PealCall(pm, addr, &inps);
    MemSemaphoreRelease(true);
    PealUnload (pm);
    MemHandleUnlock(mh);
    DmReleaseResource(mh);
    if (res!=0){
	freeall(NULL);
	WinDrawChars("Error unpacking, exiting.",25,0,0);
	return 0;
    }
    WinDrawChars("Done.",5,52,58);
    p[0]=*(inbuf+olen-1);
    p[1]=*(inbuf+olen-2);
    p[2]=*(inbuf+olen-3);
    p[3]=*(inbuf+olen-4);
    orl=(Int32*)&p;
    freeall(window);
    return *orl;
}
/*
allocstates whichMem(char *ptr){
	int i;
	for (i=0;i<nheap;i++) if(heapallocs[i]==ptr) return toHeap;
	for (i=0;i<nstor;i++) if(storallocs[i]==ptr) return toStore;
	return toAny;
}

UInt32 readfile(FileRef fr,char *buf,UInt32 size){
	UInt32 bread;
	Err err;
	if(whichMem(buf)==toStore)err=VFSFileReadData(fr,size,buf,0,&bread);
	else if(whichMem(buf)==toHeap) err=VFSFileRead(fr,size,buf,&bread);
	else return 0;
	return bread;
	UInt32 i=0;
	while((i<size)&&(bread!=0)){
		VFSFileRead(fr,32768,readbuf,&bread);
		if (bread!=0) DmWrite(buf,i,readbuf,bread);
		i+=bread;
	}
	return i;
}*/

void tapscr()
{
	WinDrawChars("Tap the screen to continue.",27,0,10);
}
struct loader lo;
 UInt32   PilotMain
   (UInt16  cmd,
    void    *cmdPBP,
    UInt16  launchFlags)
{

    if (cmd == sysAppLaunchCmdNormalLaunch)
    {
    Err    err;
    EventType    event;
    UInt16       error;
    UInt32 i=0,k=0;
    FileRef fr=0;
    PealModule *pm;
    void *addr;
    UInt32 *ptr;
    UInt32 offset,volIterator=vfsIteratorStart,bread,fsize,bcount=0;
    UInt32 widthP=320, heightP=320, depthP=16;
    Boolean enableColorP=true;
    SysAppInfoPtr sysP;
    ownerID=SysGetAppInfo(&sysP,&sysP)->memOwnerID;

    k=0;
    loadf=&lo;//(struct loader*)allocate(sizeof(struct loader),toHeap);
    if (loadf==NULL) {
	WinDrawChars("Not enough heap memory, exiting.",31,0,0);
	goto error;
     }
     err=-1;
    WinDrawChars("Loading, please wait ...",24,10,24);
    while ((volIterator!=vfsIteratorStop)&&(fr==0)){
	  if (VFSVolumeEnumerate (&volumeRef,&volIterator)==0) {
          err=VFSFileOpen (volumeRef,"/",vfsModeRead,&fr);
       }
       if(err==errNone) break;
    }
    if(fr==0){
        WinDrawChars("No file system detected !",25,0,0);
    }
    VFSFileClose(fr);
    fsize=unzip();
    if(fsize==0) goto error;
    WinDrawChars("Loading module ...",18,0,70);
    pm=PealLoad(window);
    WinDrawChars("Done",4,75,70);
    if (pm==NULL){
	WinDrawChars("Can't Load Module, exiting.",27,0,0);
	goto error;
    }
    addr=PealLookupSymbol(pm,"main");
    if (addr==NULL){
	WinDrawChars("Can't Find Symbol, exiting.",27,0,0);
	PealUnload (pm);
	goto error;
     }
    scalercache=allocate(0x96000,toHeap);
    if(scalercache==NULL){
	WinDrawChars("Not enough free memory, exiting.",27,0,0);
	PealUnload (pm);
	goto error;
    }

    WinScreenMode( winScreenModeSet, &widthP, &heightP, &depthP, &enableColorP );
    WinScreenGetAttribute(winScreenRowBytes,&rowbytes);
    bmph=BmpCreate(rowbytes,480,16,NULL,&error);//WinGetBitmap(winh);
    bits=allocate(rowbytes*480*2,toHeap);//BmpGetBits(bmph);
    bmphv3=BmpCreateBitmapV3(bmph,kDensityDouble,bits,NULL);//WinGetBitmap(winh);
    BmpDelete(bmph);

    bmph=BmpCreate(rowbytes*2,480,8,NULL,&error);//WinGetBitmap(winh);
    bmplv3=BmpCreateBitmapV3(bmph,kDensityDouble,bits,NULL);//WinGetBitmap(winh);
    BmpDelete(bmph);
    winh=WinGetDisplayWindow();
    bmph=WinGetBitmap(winh);
    scrbits=BmpGetBits(bmph);
//    winh=WinCreateBitmapWindow(bmplv3,&error);
//    WinSetActiveWindow(winh);
    depthP=8;

loopfrm:
	cont=0;
        FrmGotoForm(MainForm);
	eventloop(&event,appHandleEvent,true);
	FrmCloseAllForms();
	do {EvtGetEvent(&event,0);} while(event.eType!=0);
	if(cont==2){
		mem=allocate(memsize*1024*1024,toHeap);
		if(mem==NULL) {
			FrmCustomAlert(2000,"Not enough free RAM.","Try more realistic settings.","");
			goto loopfrm;
		}
	}
	else goto end;
    setloadf();
    if(bits!=NULL) {
	    Err err,ic;
	    char *retmsg;
	    WinDrawChars ("Initializing emulator",21,0,24);
	    WinDrawChars ("Please wait ...",15,0,36);
	    retmsg=(char*)PealCall(pm, addr, loadf);
	    WinDrawChars("Done",4,60,0);
	    WinScreenMode( winScreenModeSetToDefaults, &widthP, &heightP, &depthP, &enableColorP );
    }
    else {
            WinScreenMode( winScreenModeSetToDefaults, &widthP, &heightP, &depthP, &enableColorP );
            FrmCustomAlert(Contact,"a","a","a");
    }
    FrmCloseAllForms();
end:
    freeall(NULL);
    PealUnload(pm);
    goto the_end;
error:
    {
	EventType e;
	freeall(NULL);
	WinDrawChars("Tap the screen to continue.",27,0,10);
	do {
		EvtGetEvent (&e, evtWaitForever);
	} while ((e.eType != penDownEvent)&& (e.eType != appStopEvent));  
	FrmCloseAllForms();
    }
  }
the_end:
  return 0;
}

    static Boolean
appHandleEvent (EventPtr pEvent)
{
    FormPtr pForm;
    UInt16   formId, menuID;
    Boolean handled = false;
    if (pEvent->eType == frmLoadEvent)
    {
        formId = pEvent->data.frmLoad.formID;
        pForm  = FrmInitForm(formId);
        FrmSetActiveForm(pForm);
        if (formId == MainForm)
            FrmSetEventHandler (pForm, mainFormEventHandler);
        handled = true;
    }
    else if (pEvent->eType == menuEvent)
    {
        menuID = pEvent->data.menuOpen.menuRscID;
        handled = doMainMenu(pEvent->data.menu.itemID);
    }
    return handled;
}

    static Boolean
mainFormEventHandler(EventPtr pEvent)
{
    Boolean handled = false;
    UInt16 val;
    FormPtr pForm   = FrmGetActiveForm();
    switch (pEvent->eType)
    { 
     case frmOpenEvent:
	FrmDrawForm(pForm);
	handled = true;
        LstSetSelection(getObjectPtr(pForm,RAMSize),memsize-1);
	CtlSetLabel(getObjectPtr(pForm,RAMSizePopup),LstGetSelectionText(getObjectPtr(pForm,RAMSize),memsize-1));
	break;
     case ctlSelectEvent:
	switch (pEvent->data.ctlSelect.controlID)
	{
            case Start:
		memsize=LstGetSelection(getObjectPtr(pForm,RAMSize))+1;
                cont=2;
                handled=true;
                break;
        }
	break;
     case lstSelectEvent:
     {
        switch (pEvent->data.lstSelect.listID)
          {
          case CPUType:
		break;
          }
     }
    default:
        break;
    }
    return handled;
}

    static Boolean doMainMenu (UInt16 command)
{
    Boolean    handled    = false;
    EventType event;
    Err error;
    switch(command)
    {
        case 1000:
	cont=1;
	break;
	default:
	break;
   }
   return true;
}
